<?php

namespace Picea\Asset\Extension;

use Picea\Asset\Config;

class UrlExtension extends \Picea\Extension\UrlExtension {

    protected Config $config;

    public function __construct(Config $config, string $urlBase = "", string $assetToken = "", array $appUrl = [], bool $forceSSL = false) {
        $this->tokens[] = 'asset:path';
        $this->config = $config;

        parent::__construct($urlBase, $assetToken, $appUrl, $forceSSL);
    }

    public function parse(\Picea\Compiler\Context &$context, ?string $arguments, string $token, array $options = []) : string
    {
        if ( $token === 'asset:path' ) {
            return "<?php echo \$picea->compiler->getExtensionFromToken('$token')->buildAssetUrlFromPath($arguments) ?>";
        }

        return parent::parse($context, $arguments, $token, $options);
    }

    public function exportFunctions(): array
    {
        return array_replace([
            "asset_path" => [ $this, 'buildAssetUrlFromPath' ],
        ], parent::exportFunctions());
    }

    public function buildAssetUrlFromPath(string $uri, array $parameters = [], bool $appendVersion = true) : string
    {
        return $this->buildAssetUrl( trim($this->config->path, '/') . '/' . $uri, $parameters, $appendVersion);
    }
}
